class BaconJSONConfig: JsonApiStruct
{
	ref array<ref BaconConfigItem> items;
	
	void BaconJSONConfig()
	{
		RegV("items");
	};

	void Template(string savePath)
	{
		// version = currentVersion;
		// persistentBansEnabled = true;
		
		items = new ref array<ref BaconConfigItem>();
		BaconConfigItem newItem = new BaconConfigItem();
		newItem.Add("one", "two");
		items.Insert(newItem);
		
		PackToFile(savePath);
	};
};

class BaconConfigItem: JsonApiStruct 
{
	string var_one;
	string var_two;
	
	void BaconConfigItem() 
	{
		RegV("var_one"); RegV("var_two");
	};
	
	void Add(string one, string two)
	{
		var_one = one;
		var_two = two;
	};
};

class BaconJSONConfig_Loader
{
	static ref BaconJSONConfig m_loadedConfig;
	static string m_configFilePath = "$profile:BaconJSONConfig.json";

	static bool LoadConfig()
	{
		if (!m_loadedConfig)
			m_loadedConfig = new BaconJSONConfig();

		if (m_loadedConfig.LoadFromFile(m_configFilePath))
		{
			return true;
		}
		else 
		{
			Print("BaconJSONConfig_Loader | Database | Configuration file failed to load - trying to make a template!", LogLevel.WARNING);
			m_loadedConfig.Template(m_configFilePath);
			return false;
		};	
	};
};